//
// CamerasAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class CamerasAPI {
    /**
     Create new camera

     - parameter body: (body)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createCamera(body: CameraCreate, withOrigin: Bool? = nil, completion: @escaping ((_ data: CameraGet?,_ error: Error?) -> Void)) {
        createCameraWithRequestBuilder(body: body, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new camera
     - POST /api/v1/cameras
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "onvif_host" : "onvif_host",
  "video_analytics" : { },
  "onvif_login" : "onvif_login",
  "video_streaming" : { },
  "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "latitude" : 0.8008281904610115,
  "origin" : {
    "place_name" : "place_name",
    "place_description" : "place_description",
    "place_longitude" : 2.027123023002322,
    "camera_position_x" : 5.637376656633329,
    "camera_position_y" : 2.3021358869347655,
    "plan_id" : 7,
    "plan_name" : "plan_name",
    "place_id" : 9,
    "place_latitude" : 3.616076749251911
  },
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "video_storage" : { },
  "source" : { },
  "snapshot_url" : "http://example.com/aeiou",
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "ptz" : { },
  "name" : "name",
  "onvif_port" : 5,
  "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 1,
  "onvif_password" : "onvif_password",
  "plan_id" : 4,
  "longitude" : 6.027456183070403
}}]
     - parameter body: (body)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraGet> 
     */
    open class func createCameraWithRequestBuilder(body: CameraCreate, withOrigin: Bool? = nil) -> RequestBuilder<CameraGet> {
        let path = "/api/v1/cameras"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<CameraGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete specified camera

     - parameter cameraId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteCamera(cameraId: UUID, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteCameraWithRequestBuilder(cameraId: cameraId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete specified camera
     - DELETE /api/v1/cameras/{camera_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter cameraId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteCameraWithRequestBuilder(cameraId: UUID) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/cameras/{camera_id}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get camera with provided ID

     - parameter cameraId: (path)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCamera(cameraId: UUID, withOrigin: Bool? = nil, completion: @escaping ((_ data: CameraGet?,_ error: Error?) -> Void)) {
        getCameraWithRequestBuilder(cameraId: cameraId, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get camera with provided ID
     - GET /api/v1/cameras/{camera_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "onvif_host" : "onvif_host",
  "video_analytics" : { },
  "onvif_login" : "onvif_login",
  "video_streaming" : { },
  "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "latitude" : 0.8008281904610115,
  "origin" : {
    "place_name" : "place_name",
    "place_description" : "place_description",
    "place_longitude" : 2.027123023002322,
    "camera_position_x" : 5.637376656633329,
    "camera_position_y" : 2.3021358869347655,
    "plan_id" : 7,
    "plan_name" : "plan_name",
    "place_id" : 9,
    "place_latitude" : 3.616076749251911
  },
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "video_storage" : { },
  "source" : { },
  "snapshot_url" : "http://example.com/aeiou",
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "ptz" : { },
  "name" : "name",
  "onvif_port" : 5,
  "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 1,
  "onvif_password" : "onvif_password",
  "plan_id" : 4,
  "longitude" : 6.027456183070403
}}]
     - parameter cameraId: (path)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraGet> 
     */
    open class func getCameraWithRequestBuilder(cameraId: UUID, withOrigin: Bool? = nil) -> RequestBuilder<CameraGet> {
        var path = "/api/v1/cameras/{camera_id}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<CameraGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of cameras

     - parameter placeId: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameras(placeId: Int? = nil, withOrigin: Bool? = nil, completion: @escaping ((_ data: CameraList?,_ error: Error?) -> Void)) {
        getCamerasWithRequestBuilder(placeId: placeId, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of cameras
     - GET /api/v1/cameras
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "cameras" : [ {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  }, {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter placeId: (query)  (optional)
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraList> 
     */
    open class func getCamerasWithRequestBuilder(placeId: Int? = nil, withOrigin: Bool? = nil) -> RequestBuilder<CameraList> {
        let path = "/api/v1/cameras"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "place_id": placeId?.encodeToJSON(), 
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<CameraList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Search cameras by provided query string

     - parameter body: (body)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchCameras(body: CameraSearchBody, withOrigin: Bool? = nil, completion: @escaping ((_ data: CameraList?,_ error: Error?) -> Void)) {
        searchCamerasWithRequestBuilder(body: body, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search cameras by provided query string
     - POST /api/v1/cameras/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "cameras" : [ {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  }, {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter body: (body)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraList> 
     */
    open class func searchCamerasWithRequestBuilder(body: CameraSearchBody, withOrigin: Bool? = nil) -> RequestBuilder<CameraList> {
        let path = "/api/v1/cameras/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<CameraList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update camera with provided ID

     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter withOrigin: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateCamera(body: CameraUpdate, cameraId: UUID, withOrigin: Bool? = nil, completion: @escaping ((_ data: CameraGet?,_ error: Error?) -> Void)) {
        updateCameraWithRequestBuilder(body: body, cameraId: cameraId, withOrigin: withOrigin).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update camera with provided ID
     - PUT /api/v1/cameras/{camera_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "onvif_host" : "onvif_host",
  "video_analytics" : { },
  "onvif_login" : "onvif_login",
  "video_streaming" : { },
  "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "latitude" : 0.8008281904610115,
  "origin" : {
    "place_name" : "place_name",
    "place_description" : "place_description",
    "place_longitude" : 2.027123023002322,
    "camera_position_x" : 5.637376656633329,
    "camera_position_y" : 2.3021358869347655,
    "plan_id" : 7,
    "plan_name" : "plan_name",
    "place_id" : 9,
    "place_latitude" : 3.616076749251911
  },
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "video_storage" : { },
  "source" : { },
  "snapshot_url" : "http://example.com/aeiou",
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "ptz" : { },
  "name" : "name",
  "onvif_port" : 5,
  "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
  "place_id" : 1,
  "onvif_password" : "onvif_password",
  "plan_id" : 4,
  "longitude" : 6.027456183070403
}}]
     - parameter body: (body)  
     - parameter cameraId: (path)  
     - parameter withOrigin: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraGet> 
     */
    open class func updateCameraWithRequestBuilder(body: CameraUpdate, cameraId: UUID, withOrigin: Bool? = nil) -> RequestBuilder<CameraGet> {
        var path = "/api/v1/cameras/{camera_id}"
        let cameraIdPreEscape = "\(cameraId)"
        let cameraIdPostEscape = cameraIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{camera_id}", with: cameraIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "with_origin": withOrigin
        ])


        let requestBuilder: RequestBuilder<CameraGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
